estimate.meanvar=function(n,p) {
  e.mean=rep(0,p)
  e.var=rep(0,p)
  for(i in 1:p) {
    x=rexp(n,rate=2)
    e.mean[i]=mean(x)
    e.var[i]=var(x)
  }
  list(mean=e.mean,var=e.var)
}
print.estimateur=function() {
  estimateur=estimate.meanvar(20,2000)
  postscript("histogramme.mean.exp.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  hist(estimateur$mean,breaks="scott",main="Estimateur de l'esprance",xlab=expression(widehat(mu)),ylab="Effectif",lwd=2)
  dev.off()
  postscript("histogramme.var.exp.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  hist(estimateur$var,breaks="scott",main="Estimateur de la variance",xlab=expression(widehat(sigma^2)),ylab="Effectif",lwd=2)
  print(paste("moyenne :",mean(estimateur$mean)))
  print(paste("variance :",mean(estimateur$var)))
  print(paste("risque pour la moyenne :",mean((estimateur$mean-0.5)^2)))
  print(paste("risque pour la variance :",mean((estimateur$var-0.25)^2)))  
  dev.off()
}
estimate.mean=function(x) {
  result=rep(0,length(x))
  for(i in 1:length(x)) {
    result[i]=mean(x[1:i])
  }
  result
}
print.slln=function() {
  fin=seq(30,2000)
  x=rexp(2000,rate=2)
  x.mean=estimate.mean(x)
  postscript("slln.mean.end.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(fin,x.mean[30:2000],type="l",ylab=expression(widehat(mu)[n]),xlab=expression(n),main="Estimateur de l'esprance",lwd=2)
  lines(c(30,2000),c(0.5,0.5),col="red",lwd=2)
  dev.off()
  postscript("slln.mean+sd.end.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(fin,x.mean[30:2000],type="l",ylab=expression(widehat(mu)[n]),xlab=expression(n),main="Estimateur de l'esprance",lwd=2)
  lines(c(30,2000),c(0.5,0.5),col="red",lwd=2)
  lines(fin,0.5+2*0.25/sqrt(fin),col="blue",lwd=2)
  lines(fin,0.5-2*0.25/sqrt(fin),col="blue",lwd=2)
  dev.off()

  dbut=seq(1,100)
  postscript("slln.mean.begin.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(dbut,x.mean[1:100],type="l",ylab=expression(widehat(mu)[n]),xlab=expression(n),main="Estimateur de l'esprance",lwd=2)
  lines(c(1,100),c(0.5,0.5),col="red",lwd=2)
  dev.off()
  postscript("slln.mean+sd.begin.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(dbut,x.mean[1:100],type="l",ylab=expression(widehat(mu)[n]),xlab=expression(n),main="Estimateur de l'esprance",lwd=2)
  lines(c(1,100),c(0.5,0.5),col="red",lwd=2)
  lines(dbut,0.5+2*0.25/sqrt(dbut),col="blue",lwd=2)
  lines(dbut,0.5-2*0.25/sqrt(dbut),col="blue",lwd=2)
  dev.off()
}

print.centrallimite=function() {
  postscript("centralelimite.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.4,0.2,0.4,0.2),mfrow=c(2,3),oma=c(0.1,0.3,1.5,0.1))
  base=seq(-5,5,length=500)
  for(n in c(1,2,5,7,10,20)) {
    estimateur=estimate.meanvar(n,5000)
    hist(sqrt(n)*(estimateur$mean-0.5),prob=T,breaks="scott",main=n,xlab=expression(widehat(mu)),ylab="",lwd=2)
    lines(base,dnorm(base,sd=0.5),col="red",lwd=2)
  }
  title(expression(paste("Evolution de la dispersion de ",widehat(mu))),outer=T,cex=2)
  dev.off()
}

print.binommv=function() {
  # pile ou face truqu, P d'avoir pile = 0.6 (cod par 1)
  echant=runif(2000)
  echant[echant<0.4]=0
  echant[echant>=0.4]=1
  estimate.p=estimate.mean(echant)
  zone=seq(1,100)
  postscript("binom.mv.begin.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(zone,estimate.p[zone],type="l",ylab=expression(widehat(p)[n]),xlab=expression(n),main="Estimateur de p",lwd=2)
  lines(range(zone),c(0.6,0.6),col="red",lwd=2)
  dev.off()
  zone=seq(30,2000)
  postscript("binom.mv.end.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(zone,estimate.p[zone],type="l",ylab=expression(widehat(p)[n]),xlab=expression(n),main="Estimateur de p",lwd=2)
  lines(range(zone),c(0.6,0.6),col="red",lwd=2)
  dev.off()
}

print.binombayes=function() {
  # pile ou face truqu, P d'avoir pile = 0.6 (cod par 1)
  echant=runif(2000)
  echant[echant<0.4]=0
  echant[echant>=0.4]=1
  base=seq(0,1,length=256)
  # prior uniform
  postscript("binom.bayes.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.4,0.6,0.4,0.2),mfrow=c(2,3),oma=c(0.1,0.3,1.5,0.1))
  for(i in c(20,50,100,500,1000,2000)) {
    k=sum(echant[1:i])
    plot(base,dbeta(base,shape1=k+1,shape2=i-k+1),type="l",ylab=expression(paste(p,"(",p,"|",P[n],")")),xlab="",main=paste("n=",i,sep=""),lwd=2)
  }
  title(expression(paste(plain(Evolution)," de ",p,"(",p,"|",P[n],")")),outer=T,cex=2)
  dev.off()
  # prior beta(60,50)
  alpha=60
  beta=50
  postscript("binom.bayes.beta60-50.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.4,0.6,0.4,0.2),mfrow=c(2,3),oma=c(0.1,0.3,1.5,0.1))
  for(i in c(20,50,100,500,1000,2000)) {
    k=sum(echant[1:i])
    plot(base,dbeta(base,shape1=k+alpha,shape2=i-k+beta),type="l",ylab=expression(paste(p,"(",p,"|",P[n],")")),xlab="",main=paste("n=",i,sep=""),lwd=2)
    lines(base,dbeta(base,shape1=k+1,shape2=i-k+1),col="blue",lwd=2)
  }
  title(expression(paste(plain(Evolution)," de ",p,"(",p,"|",P[n],")")),outer=T,cex=2)
  dev.off()
}

print.beta=function() {
  base=seq(0,1,length=512)
  postscript("beta60-50.eps",onefile=F,paper="special",width=11.69,height=8.27)
  par(mai=c(0.8,0.8,0.4,0.1))
  plot(base,dbeta(base,shape1=60,shape2=50),xlab="",ylab="",main="Densit de la loi Beta(60,50)",type="l",lwd=2)
  dev.off()
}

print.estimateur()
print.slln()
print.centrallimite()
print.binommv()
print.binombayes()
print.beta()
